﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using System.IO;

namespace XML1
{
    public partial class Form1 : Form
    {
        MyData data;

        public Form1()
        {
            InitializeComponent();

            data = new MyData();

            for (int i = 1; i <= 3; i++)
            {
                MyPoint point = new MyPoint();
                point.X = i;
                point.Y = i;
                point.Name = "bod " + i;
                data.Points.Add(point);
            }
        }

        private void show (TreeNodeCollection target,
                           XmlElement elem)
        {
            TreeNode item = new TreeNode(elem.Name);
            item.ForeColor = Color.Blue;
            target.Add (item);
            foreach (XmlAttribute attr in elem.Attributes)
            {
                TreeNode subitem =
                    new TreeNode("attribute: " + 
                        attr.Name + "=" + attr.Value);
                subitem.ForeColor = Color.Orange;
                item.Nodes.Add(subitem);
            }

            foreach (XmlNode node in elem.ChildNodes)
            {
                XmlElement e = node as XmlElement;
                if (e != null)
                    show(item.Nodes, e);
                else
                {
                    XmlText t = node as XmlText;
                    if (t != null)
                    {
                        TreeNode subitem =
                            new TreeNode("text: " + t.Value);
                        subitem.ForeColor = Color.Green;
                        item.Nodes.Add(subitem);
                    }
                    else
                    {
                        TreeNode subitem =
                            new TreeNode(node.GetType().Name);
                        subitem.ForeColor = Color.Red;
                        item.Nodes.Add(subitem);
                    }
                }
            }
        }

        private void read(string fileName)
        {
            // using System.Xml;
            XmlDocument doc = new XmlDocument ();
            // doc.Load(fileName);
            doc.LoadXml("<knihovna/>");
            XmlElement elem = doc.DocumentElement;

            XmlElement e = doc.CreateElement("kniha");
            elem.AppendChild(e);

            XmlElement e2 = doc.CreateElement("stranka");
            e.AppendChild(e2);

            e2.SetAttribute("cislo", "1");

            show(treeView1.Nodes, elem);
            doc.Save("c:\\work\\zc\\data2.xml");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            /*
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                read(openFileDialog1.FileName);
            }
            */
            read ("c:\\work\\zc\\data.xml");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // using System.IO;
            StreamWriter stream =
                new StreamWriter("c:\\work\\zc\\data3.xml");

            // using System.Xml.Serialization;
            XmlSerializer writer =
                new XmlSerializer(typeof(MyData));

            writer.Serialize (stream, data);

            stream.Close ();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            StreamReader stream =
                new StreamReader("c:\\work\\zc\\data3.xml");

            XmlSerializer writer =
                new XmlSerializer(typeof(MyData));

            object obj = writer.Deserialize(stream);

            data = obj as MyData;
            propertyGrid1.SelectedObject = data;

            stream.Close();

        }
    }
}
